<?php
	
	include_once "SkinBuilder.view.php";

	/**
	 * Glover_SkinBuildParser
	 * ѡ󥰤ơξݻ뤿Υ饹
	 * @since PHP4.0
	 * @author derui
	 */
	class Glover_SkinBuildParser {
		
		var $m_SkinName;
		var $m_SkinContent;
		var $m_ContentCount;
		
		function Glover_SkinBuildParser() {
			$this->m_SkinName = "";
			$this->m_SkinContent = array();
			$this->m_ContentCount = 0;
		}
		
		/**
		 * getBaseHeader
		 * basecenterboxΥإåʬ֤
		 * @param void
		 * @return string
		 */
		function getBaseHeader($skin) {
			
			$cen = $this->parseContentStyle($skin, "centerbox");
			$bas = $this->parseContentStyle($skin, "base");
			$ps = $this->parseContentStyle($skin, "pagestyle");
			$tmp = <<<HEADER
<div id="pagestyle" style="$ps">
<div id="centerbox" style="$cen">
	<div id="base" style="$bas">
	١
HEADER;
			return $tmp;
		}
		
		/**
		 * getBaseHooter
		 * basecenterboxΥեåʬ֤
		 * @param void
		 * @return string
		 */
		function getBaseHooter() {
			return "\t</div>\n</div>\n</div>\n";
		}
		
		/**
		 * parseSkin
		 * βϤԤ
		 * @param string $name
		 * @return void
		 */
		function parseSkin($name) {
			//ޤϡߤΥñ˲Ϥ롣
			//ϤȤϸäƤ⡢ºݤˤȤϡbodyʲ顢
			//ƥidƤ˥˥塼ʬΤ֤Ǥ롣
			$file = new GFile(SKINPATH.$name.".html");
			$line = $file->getAllLine();
			$file->destroy();
			reset($line);
			//bodyޤǤפʤΤǡޤǤʬ򤹤٤ƺƤ
			while (list($key ,$val) = each($line)) {
				if (preg_match("/<body>/",$val)) {
					break;
				}
			}
			
			//ˡcenterboxbaseפǤΤǡ롣
			$count = 1;
			while (list($key, $val) = each($line)) {
				$t = $val;
				if (preg_match("/<div[ ]*id=\"(.+?)\".+$/", $t, $match)) {
					if ($match[1] == "centerbox" || $match[1] == "base" || $match[1] == "pagestyle") {
						//ɤФ
						continue;
					}
			
					$contentid = $match[1];
					//idơΥ᥿롣
					$tmp = array($t);
					while (list($key, $val) = each($line)) {
						if (preg_match("/<\/div>/", $val)) {
							break;
						}
					}
					
					//Ūˡˤϥ᥿ʳ򤤤뤳Ȥ϶ؤƤΤǡ
					//ޤ굤ˤ˸롣
					$meta = "";
					foreach ($tmp as $l) {
						if (preg_match("/\{(.+)\}/", $l, $match)) {
							//᥿ȯϤäݻƤ
							$meta = $match[1];
							break;
						}
					}
					
					$menuname = "content_menu" . $count;
					
					$cstyle = $this->parseContentStyle($name,$contentid);
					
					//ǽäΤǡƥĽѤξformȤƽƤ롣
					//ȤϸäƤ⡢ƥĤξΤϡCSSˤǽΤǡ
					//CSSȤ߹ʤƥIDȥ᥿󡢤ƥ饤CSSȤʤ롣
					$content = "<form id=\"" . $menuname . "_initialize_info\">\n";
					$content .= "<input type=\"hidden\" name=\"content_meta\" value=\"$meta\"/>\n";
					$content .= "<input type=\"hidden\" name=\"content_id\" value=\"$contentid\"/>\n";
					$content .= "<input type=\"hidden\" name=\"content_style\" value=\"$cstyle\"/>\n";
					$content .= "</form>\n";
					
					//ǽλƥĤȤƽ롣
					$this->m_SkinContent[] = $content;
					$count++;
				} else if (preg_match("/<\/body>/", $t)) {
					break;
				}
			}
		}
		
		/**
		 * _parseContentStyle
		 * ꤵ줿ƥĤΥ륷ʬ롣
		 * @param $contentid 륳ƥĤΥ̾
		 * @param $content 륳ƥID
		 * @return string 饤CSS
		 */
		function parseContentStyle($contentid, $content) {
			$file = new GFile(SKINPATH.$contentid."/".$contentid.".css");
			
			//򤤤äʸȤƼ
			$line = implode("", $file->getAllLine());
			$line = explode("\n", $line);
			$line = implode("", $line);
			$query = "/div#$content.*?\{(.+?)\}/";
			//ɽǸ򤫤ơȯ롣
			if (preg_match($query, $line, $match)) {
				//Ĥäϡñˤ֤Τߡ
				return $match[1];
			}
			
			return "";
		}
		
		/**
		 * getContent
		 * ߤΰ֤ˤ륳ƥĤ֤
		 * @param void
		 * @return string
		 */
		function getContent() {
			return $this->m_SkinContent[$this->m_ContentCount++];
		}
		
		/**
		 * resetContentCount
		 * ƥĥȤ롣
		 * @param void
		 * @return void
		 */
		function resetContentCount() {
			$this->m_ContentCount = 0;
		}
		
		/**
		 * isEnd
		 * 
		 * @param void
		 * @return 
		 */
		function isEnd() {
			if (count($this->m_SkinContent) <= $this->m_ContentCount) {
				return true;
			}
			return false;
		}
	}

	/**
	 * Glover_SkinBuilder
	 * ӥ饹
	 * @package Glover
	 * @since PHP4.0
	 * @author derui
	 */
	class Glover_SkinBuilder {
		
		/**
		 * run
		 * ӥưꤹ롣
		 * @param void
		 * @return void
		 */
		function run($param) {
			
			switch ($param) {
				case "sef":
					//Խ
					//򤵤ȡ򤷤ɥӥ̤ڤؤ롣
					SkinBuilder_dispSelectEditSkinForm();
					break;
				case "new":
					//ȤϸäƤ⡢ºݤ˹ԤϡľǤȤۤȤѲϤʤ
					$this->_createNewSkin();
					break;
				case "edit":
					//Խե뤫ɤ߽ФƥĤȥ١ξƹ
					//ԽǽȤ롣
					SkinBuilder_dispEditForSkinBuilder();
					break;
				case "mdfy":
					//ιӥ줿Ƽ
					//ڤʬ줾CSSHTML˵Ҥ餦
					$this->_modifySkinBySkinBuilder();
					break;
			}
		}
		
		/**
		 * _createNewSkin
		 * 롣
		 * @param void
		 * @return void
		 */
		function _createNewSkin() {
			global $GloverObject;
			$file = new Glover_SkinFile;
			
			//
			$file->createEmptySkin($GloverObject->getOT('skin_name'));
			$GloverObject->setOT('skin', $GloverObject->getOT('skin_name'));
		
			//塢ΥCSSˡǥեȤȤʤbasecenterboxξ񤭽ФƤ
			$f = new GFile(SKINPATH.$GloverObject->getOT('skin').".css");
			$f->clear();
			$tmp = <<<DEFAULT
div#pagestyle {
	text-align : center;
	width: 100%;
}
div#centerbox {
	width : 100%;
	text-align : left;
	padding: 0px auto;
}

div#base {
	width : 100%;
	padding: 0px auto;
	text-align:left;
	position: relative;
	left:0px;
	top:0px;
	border: 1px solid #A0F0A0;
}
DEFAULT;
			$f->writeLine($tmp);
			$f->destroy();
			
			SkinBuilder_dispFirstEditForSkinBuilder($GloverObject->getOT('skin_name'));
		}
		
		/**
		 * _modifySkinBySkinBuilder
		 * ƤѿϤơCSSHTML򹹿Ƥ롣
		 * @param void
		 * @return void
		 */
		function _modifySkinBySkinBuilder() {
			//Ϥ줿ѥ᡼ʬͤκƹۤԤ
			global $GloverObject;
			
			//ޤcssե򳫤ˡե̾롣
			$file = new GFile(SKINPATH.$GloverObject->getOT('file_name')."/".$GloverObject->getOT('file_name').".css");
			$html = new GFile(SKINPATH.$GloverObject->getOT('file_name').".html");
			$file->clear();
			$html->clear();
			
			//HTML˽ʤɤʤɤ񤭽Ф
			$skin = SKINPATH.$GloverObject->getOT('file_name')."/".$GloverObject->getOT('file_name').".css";
			$tmp = <<<HEADER
<head>
<meta http-equiv="Content-Type" content="text/html; charset=EUC-JP"/>
<meta http-equiv="Content-Style-Type" content="text/css"/>
<link rel="stylesheet" href="$skin" type="text/css"/>
</head>
<body>

HEADER;
			$html->writeLine($tmp);
			
			//١centerboxstylesheethtmlʬ롣
			$return = $this->_getCenterBoxAndBaseStyle();
			$html->writeLine($return[1]);
			$file->writeLine($return[0]);
			
			//ƥĤ롣
			$content = $this->_getContentStyle();
			
			foreach ($content as $c) {
				$file->writeLine($c[0]);
				$html->writeLine($c[1]);
			}
			
			$html->writeLine("</div>\n</body>\n</html>\n");
			$html->destroy();
			$file->destroy();
			
		}
		
		/**
		 * _getCenterBoxAndBaseStyle
		 * centerboxbaseΥ
		 * @param void
		 * @return array Ƭstylesheethtml롣
		 */
		function _getCenterBoxAndBaseStyle() {
			//ͥåʤɤ⤳롣
			$centerbox = "div#centerbox {\n";
			//ޤϥ١񤭽ФƤ
			$return = "";
			$html = "";
			
			{
				//bstyle_font
				
				$return = "@charset \"EUC-JP\";\n\n";
				$return .= "div#base {\n";
				$split = explode("=", $GloverObject->getOT('bstyle_font'));
				//ơ줾Υѥ᡼񤭽Ф
				if ($split[1] == "") {
					$split[1] = "12px";
				}
				$return .= "font-size : ".$split[1] . ";\n";
			}
			
			{
				//bstyle_bg
				$split = explode("&", $GloverObject->getOT('bstyle_bg'));
				$param = array();
				foreach ($split as $t) {
					list($key, $var) = explode("=", $t);
					$param[$key] = $var;
				}
				
				//ͥåθ塢ѿɲ
				if ($param['bg_color'] == "" || $param['bg_color'] == "#000") {
					$param['bg_color'] = "#ffffff";
				}
				if ($param['bg_image'] == "") {
					$param['bg_image'] = "none";
				}
				if ($param['bg_repeat'] == "") {
					$param['bg_repeat'] = "no-repeat";
				}
				
				$return .= "background-color : ". $param['bg_color']. ";\n";
				$retrun .= "background-image : ". $param['bg_image']. ";\n";
				$return .= "background-repeat : ". $param['bg_repeat']. ";\n";
			}
			
			{
				//bstyle_align
				//alignϡcenterbox˵ҤΤǤ롣
				$split = explode("&", $GloverObject->getOT('bstyle_align'));
				$param = array();
				foreach ($split as $t) {
					list($key, $var) = explode("=", $t);
					$param[$key] = $var;
				}
				
				if ($param['width'] == "0") {
					$param['width'] = "100%";
				}
				if ($param['height'] == "0") {
					$param['height'] = "100%";
				}
				
				$centerbox .= "width : ".$param['width']. ";\n";
				$centerbox .= "height : ".$param['height']. ";\n";
				$return .= "width : 100%;\nheight : 100%;\n";
			}
			
			{
				//bstyle_meta
				$split = explode("=", $GloverObject->getOT('bstyle_meta'));
				if ($split[1] != "" || $split[1] != "undefined") {
				//᥿ϡHTML˽񤭽ФʤФʤʤΤǡα
					$meta = "{" . $split[1] . "}";
				}
				$return .= "}\n";
			}
			
			$html = "<div id=\"pagestyle\">\n";
			$html .= "<div id=\"centerbox\">\n<div id=\"base\">\n$meta\n</div>\n";
			$html .= "</div>\n";
			
			//CSSˡcenterboxξ񤭽Ф
			$return .= "div#pagestyle {\ntext-align : ".$param['align'].";\nwidth:100%;\n}\n".$centerbox."\nmargin : 0px auto;\n}\n\n";
			
			//ڡ򵭽Ҥ
			$return .= "body {\n";
			{
				//pstyle_bg
				//alignϡcenterbox˵ҤΤǤ롣
				$split = explode("&", $GloverObject->getOT('pstyle_bg'));
				$param = array();
				foreach ($split as $t) {
					list($key, $var) = explode("=", $t);
					$param[$key] = $var;
				}
				
				if ($param['bg_color'] == "" || $param['bg_color'] == "#000") {
					$param['bg_color'] = "#ffffff";
				}
				if ($param['bg_image'] != "") {
					$return .= "background-image : ". $param['bg_image']. ";\n";
				}
				if ($param['bg_repeat'] == "") {
					$param['bg_repeat'] = "no-repeat";
				}
				$return .= "background-color : ". $param['bg_color'].";\n";
				
				$return .= "background-repeat : ". $param['bg_repeat']. ";\n";
			}
			$return .= "}\n";
			
			return array($return, $html);
		}
		
		/**
		 * _getContentStyle
		 * ƥĤHTMLstylesheet
		 * @param void
		 * @return array ĤǤˡstylehtmlCSSäƤ롣
		 */
		function _getContentStyle() {
			//¸ߤ륳ƥĤ񤭽Ф
			global $GloverObject;
			$mname = "content_menu";
			$count = 1;
			$contentname = "";
			$return = array();
			
			while ($GloverObject->getOT($mname.$count."_info") != "") {
				//ǽinfo顣
				$split = explode("&", $GloverObject->getOT($mname.$count."_info"));
				$param = array();
				foreach ($split as $t) {
					list($key, $var) = explode("=", $t);
					$param[$key] = $var;
				}
				//infoξ򸵤ˤơ񤭽ФƤ
				$contentname = $param["content_name"];
				$meta = $param["meta"];
				
				$tmp = array();
				$tmp[1] = "<div id=\"$contentname\">\n$meta\n</div>\n";
				
				if ($param['width'] == "0") {
					$param['width'] = "100px";
				}
				if ($param['height'] == "0") {
					$param['height'] = "100px";
				}
				
				if ($param['left'] == "0") {
					$param['left'] = "0px";
				}
				if ($param['top'] == "0") {
					$param['top'] = "0px";
				}
				$tmp[0] = "div#".$contentname." {\n";
				$tmp[0] .= "left : ".$param["left"]. ";\n";
				$tmp[0] .= "top : ".$param["top"]. ";\n";
				$tmp[0] .= "width : ".$param["width"]. ";\n";
				$tmp[0] .= "height : ". $param["height"]. ";\n";
				
				//font
				$split = explode("&", $GloverObject->getOT($mname.$count."_font"));
				$param = array();
				foreach ($split as $t) {
					list($key, $var) = explode("=", $t);
					$param[$key] = $var;
				}
				
				if ($param["font_size"] == "" || $param["font_size"] == "0") {
					$param["font_size"] = "12px";
				}
				if ($param["fontcolor_r"] == "" || $param["fontcolor_r"] == "0") {
					$param["fontcolor_r"] = "00";
				}
				if ($param["fontcolor_g"] == "" || $param["fontcolor_g"] == "0") {
					$param["fontcolor_g"] = "00";
				}
				if ($param["fontcolor_b"] == "" || $param["fontcolor_b"] == "0") {
					$param["fontcolor_b"] = "00";
				}
				$tmp[0] .= "font-size : ".$param["font_size"].";\nposition : absolute;\n";
				$tmp[0] .= "color : #".$param["fontcolor_r"].$param["fontcolor_g"].$param["fontcolor_b"].";\n";
				
				//background
				$split = explode("&", $GloverObject->getOT($mname.$count."_background"));
				$param = array();
				foreach ($split as $t) {
					list($key, $var) = explode("=", $t);
					$param[$key] = $var;
				}
				if ($param['bg_color'] == "" || $param['bg_color'] == "#000") {
					$param['bg_color'] = "#ffffff";
				}
				if ($param['bg_image'] != "none") {
					$tmp[0] .= "background-image : ". $param['bg_image']. ";\n";
				}
				if ($param['bg_repeat'] == "") {
					$param['bg_repeat'] = "no-repeat";
				}
				$tmp[0] .= "background-color : ". $param['bg_color'].";\n";
				$tmp[0] .= "background-repeat : ". $param['bg_repeat']. ";\n";
				
				$tmp[0] .= "}\n\n";
				
				//title13
				for ($i = 1;$i <= 3;$i++) {
					$split = explode("&", $GloverObject->getOT($mname.$count."_title".$i));
					$param = array();
					foreach ($split as $t) {
						list($key, $var) = explode("=", $t);
						$param[$key] = $var;
					}
					
					if ($param["font_block_size"] == "" || $param["font_block_size"] == "0") {
						$param["font_block_size"] = "14px";
					}
				
					$tmp[0] .= "div#".$contentname." .titleblock".$i." {\n";
					$tmp[0] .= "font-size : ".$param["font_block_size"].";\n";
					$tmp[0] .= "margin-top : 0px;\nmargin-bottom:0px;\n}\n\n";
					
					switch ($i) {
						case 1:
							$tmp[0] .= "div#".$contentname." h2 {\n";
							break;
						case 2:
							$tmp[0] .= "div#".$contentname." h3 {\n";
							break;
						case 3:
							$tmp[0] .= "div#".$contentname." h4 {\n";
							break;
					}
					
					//ͤν
					if ($param["titlebordercolor_r"] == "" || $param["titlebordercolor_r"] == "0") {
						$param["titlebordercolor_r"] = "ff";
					}
					if ($param["titlebordercolor_g"] == "" || $param["titlebordercolor_g"] == "0") {
						$param["titlebordercolor_g"] = "ff";
					}
					if ($param["titlebordercolor_b"] == "" || $param["titlebordercolor_b"] == "0") {
						$param["titlebordercolor_b"] = "ff";
					}
					
					if ($param["font_size"] != "" && $param["font_size"] != "0px") {
						$tmp[0] .= "font-size: ".$param["font_size"].";\n";
					}
					$color = "#".$param["titlebordercolor_r"].$param["titlebordercolor_g"].$param["titlebordercolor_b"];
					
					//ޡ󤪤ӥѥǥ󥰤ͤĶĹ
					$param["titlemargin_t"] = $this->_checkMarginAndPadding($param["titlemargin_t"]);
					$param["titlemargin_l"] = $this->_checkMarginAndPadding($param["titlemargin_l"]);
					$param["titlemargin_r"] = $this->_checkMarginAndPadding($param["titlemargin_r"]);
					$param["titlemargin_b"] = $this->_checkMarginAndPadding($param["titlemargin_b"]);
					
					$param["titlepadding_t"] = $this->_checkMarginAndPadding($param["titlepadding_t"]);
					$param["titlepadding_l"] = $this->_checkMarginAndPadding($param["titlepadding_l"]);
					$param["titlepadding_r"] = $this->_checkMarginAndPadding($param["titlepadding_r"]);
					$param["titlepadding_b"] = $this->_checkMarginAndPadding($param["titlepadding_b"]);
					
					if ($param["titleborderwidth"] == "" || $param["titleborderwidth"] == "0") {
						$param["titleborderwidth"] = "0px";
					}
					if ($param["titleborderstyle"] == "") {
						$param["titleborderstyle"] = "solid";
					}
					
					$tmp[0] .= "margin : ".$param["titlemargin_t"]." ".$param["titlemargin_l"]." ".$param["titlemargin_r"]." ".$param["titlemargin_b"].";\n";
					$tmp[0] .= "padding : ".$param["titlepadding_t"]." ".$param["titlepadding_l"]." ".$param["titlepadding_r"]." ".$param["titlepadding_b"].";\n";
					$tmp[0] .= "border : ".$param["titleborderwidth"]." ".$param["titleborderstyle"]." ".$color.";\n}\n\n";
				}
				
				//list13
				$split = explode("&", $GloverObject->getOT($mname.$count."_list"));
				$param = array();
				foreach ($split as $t) {
					list($key, $var) = explode("=", $t);
					$param[$key] = $var;
				}
				
				if ($param["list_type"] == "") {
					$param["list_type"] = "symbol";
				}
				if ($param["font_size"] == "" || $param["font_size"] == "0") {
					$param["font_size"] = "12px";
				}
				
				if ($param["list_type"] == "symbol") {
					//ܥλ
					$tmp[0] .= "div#".$contentname." .list_1 {\n";
					$tmp[0] .= "list-style-type : ".$param["symboltype1"].";\n";
					$tmp[0] .= "font-size : ".$param["font_size"].";\n}\n\n";
					$tmp[0] .= "div#".$contentname." .list_2 {\n";
					$tmp[0] .= "list-style-type : ".$param["symboltype2"].";\n";
					$tmp[0] .= "font-size : ".$param["font_size"].";\n}\n\n";
					$tmp[0] .= "div#".$contentname." .list_3 {\n";
					$tmp[0] .= "list-style-type : ".$param["symboltype3"].";\n";
					$tmp[0] .= "font-size : ".$param["font_size"].";\n}\n\n";
				} else {
					$tmp[0] .= "div#".$contentname." .list_1 {\n";
					$tmp[0] .= "list-style-image : ".$param["symbolgraph1"].";\n";
					$tmp[0] .= "font-size : ".$param["font_size"].";\n}\n\n";
					$tmp[0] .= "div#".$contentname." .list_2 {\n";
					$tmp[0] .= "list-style-image : ".$param["symbolgraph2"].";\n";
					$tmp[0] .= "font-size : ".$param["font_size"].";\n}\n\n";
					$tmp[0] .= "div#".$contentname." .list_3 {\n";
					$tmp[0] .= "list-style-image : ".$param["symbolgraph3"].";\n";
					$tmp[0] .= "font-size : ".$param["font_size"].";\n}\n\n";
				}
				
				//annoration
				$split = explode("&", $GloverObject->getOT($mname.$count."_annoration"));
				$param = array();
				foreach ($split as $t) {
					list($key, $var) = explode("=", $t);
					$param[$key] = $var;
				}
				
				$tmp[0] .= "div#$contentname .notesblock {\n";
				
				if ($param["font_size"] == "" || $param["font_size"] == "0") {
					$param["font_size"] = "10px";
				}
				if ($param["fontcolor_r"] == "" || $param["fontcolor_r"] == "0") {
					$param["fontcolor_r"] = "00";
				}
				if ($param["fontcolor_g"] == "" || $param["fontcolor_g"] == "0") {
					$param["fontcolor_g"] = "00";
				}
				if ($param["fontcolor_b"] == "" || $param["fontcolor_b"] == "0") {
					$param["fontcolor_b"] = "00";
				}
				$tmp[0] .= "font-size : ".$param["font_size"].";\n";
				$tmp[0] .= "color : #". $param["fontcolor_r"].$param["fontcolor_g"].$param["fontcolor_b"].";\n";
				if ($param["useborder"] == "use") {
				
					if ($param["bordercolor_r"] == "" || $param["bordercolor_r"] == "0") {
						$param["bordercolor_r"] = "00";
					}
					if ($param["bordercolor_g"] == "" || $param["bordercolor_g"] == "0") {
						$param["bordercolor_g"] = "00";
					}
					if ($param["bordercolor_b"] == "" || $param["bordercolor_b"] == "0") {
						$param["bordercolor_b"] = "00";
					}
					if ($param["borderwidth"] == "" || $param["borderwidth"] == "0") {
						$param["borderwidth"] = "1px";
					}
					if ($param["borderstyle"] == "") {
						$param["borderstyle"] = "solid";
					}
					$color = "#".$param["bordercolor_r"].$param["bordercolor_g"].$param["bordercolor_b"];
					$tmp[0] .= "border :".$param["borderwidth"]." ".$param["borderstyle"]." ".$color.";\n";
				}
				$tmp[0] .= "}\n\n";
				$return[] = $tmp;
				$count++;
			}
			
			return $return;
		}
		
		/**
		 *  _checkMarginAndPadding
		 * ޡ󤪤ӥѥǥ󥰤ͤåơ֤
		 * @param $check åо
		 * @return string ʸ
		 */
		function _checkMarginAndPadding($margin) {
			if ($margin == "" || $margin == "0") {
				$margin = "0px";
			} else {
				if (!preg_match("/px/",$margin)) {
					$margin .= "px";
				}
			}
			return $margin;
		}
	}
?>